Attribute VB_Name = "modPrincipal"
Option Explicit
'Executar outros programas a partir do VB6
Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
'variveis do banco de dados
Global NomeDoArquivo As String
Global wks As Workspace, dbs As Database
Global rstTemp(3) As Recordset
Global SQL(3) As String
'variveis e constantes principais de qualquer programa
Global IdUsuario As Byte
Global Usuarios(10, 2) As String
Global NrUsuarios As Byte
Global Prt As Printer
Global Flag(1) As Byte
Global BackSpace As Byte
Global Form As Byte
Global ii As Integer
Global i As Integer, j As Integer
Global n As Integer, o As Integer, p As Integer
Global X As Single, Y As Single, Z As Single
Global Total As Currency, Total2 As Currency
Global TT As String
Global XX As String, YY As String, ZZ As String
Global DB As String
Global UU As String
Global resp
'variveis especificas do programa
Global Margem As String
Global Alteracao As Boolean
Global Transferir As Boolean
Global Mesa As Byte, NovaMesa As Byte, SMesa As String
Global Digito As Byte
Global PercGarcom As Byte, PercCover As Byte
Global Impressao As Boolean
Global Parametro(8) As String
Global Ferramenta As Byte
Global MesasDemo As Byte
Global Proprietario As String
'variveis p/ validao de CPF
Global CPF As String
Global Valido As Boolean

Sub Main()
  Randomize Timer
  MesasDemo = 201
  'Abre o Banco de Dados
  On Error GoTo ErroAbrirBanco
  NomeDoArquivo = App.Path & "\Dados.mdb"
  Set wks = Workspaces(0)
  Set dbs = wks.OpenDatabase(NomeDoArquivo, False, False, ";pwd=" & "245249")
  'Inicializa a Tabela T_Abertas
  SQL(0) = "SELECT * FROM T_Abertas;"
  Set rstTemp(0) = dbs.OpenRecordset(SQL(0), dbOpenDynaset)
  If rstTemp(0).RecordCount = 0 Then
    For i = 1 To 200
      With rstTemp(0)
        .AddNew
        .Fields("IdMesa").Value = Format(i, "00#")
        .Update
      End With
    Next i
  End If
  rstTemp(0).Close
  'Inicializa a Tabela T_Garcons
  SQL(0) = "SELECT * FROM T_Garcons;"
  Set rstTemp(0) = dbs.OpenRecordset(SQL(0), dbOpenDynaset)
  If rstTemp(0).RecordCount = 0 Then
    For i = 0 To 24
      With rstTemp(0)
        .AddNew
        .Fields("IdOrdem").Value = i + 1
        .Fields("IdGarcom").Value = i
        If i = 0 Then
          .Fields("Nome").Value = "CASA"
        End If
        .Update
      End With
    Next i
  End If
  rstTemp(0).Close
  'Inicializa a Tabela T_Grupos
  SQL(0) = "SELECT * FROM T_Grupos;"
  Set rstTemp(0) = dbs.OpenRecordset(SQL(0), dbOpenDynaset)
  If rstTemp(0).RecordCount = 0 Then
    For i = 0 To 9
      With rstTemp(0)
        .AddNew
        .Fields("IdGrupo").Value = i + 1
        .Fields("Digito").Value = i
        .Update
      End With
    Next i
  End If
  rstTemp(0).Close
 'Inicializa a Tabela T_Produtos
  SQL(0) = "SELECT * FROM T_Produtos;"
  Set rstTemp(0) = dbs.OpenRecordset(SQL(0), dbOpenDynaset)
  If rstTemp(0).RecordCount = 0 Then
    n = 0
    o = 0
    For i = 1 To 1000
      With rstTemp(0)
        .AddNew
        .Fields("IdOrdem").Value = i
        .Fields("IdProduto").Value = Format(i - 1, "00#")
        .Fields("Digito").Value = o
        .Fields("Descricao").Value = "z"
        .Update
      End With
      n = n + 1
      If n = 100 Then
        n = 0
        o = o + 1
      End If
    Next i
  End If
  rstTemp(0).Close
  'Inicializa a Tabela T_Parametros
  SQL(0) = "SELECT * FROM T_Parametros;"
  Set rstTemp(0) = dbs.OpenRecordset(SQL(0), dbOpenDynaset)
  If rstTemp(0).RecordCount = 0 Then
    With rstTemp(0)
      .AddNew
      .Fields("IdParametro").Value = 1
      .Fields("PercGarcom").Value = 10
      .Update
      .Close
    End With
    PercGarcom = 10
  Else
    Parametro(0) = rstTemp(0)!NomeFantasia & ""
    Parametro(1) = rstTemp(0)!Endereco1 & ""
    Parametro(2) = rstTemp(0)!Endereco2 & ""
    Parametro(3) = rstTemp(0)!Frase1 & ""
    Parametro(4) = rstTemp(0)!Frase2 & ""
    Parametro(5) = rstTemp(0)!MargemEsquerda
    Parametro(6) = rstTemp(0)!LinhasBranco
    Parametro(7) = rstTemp(0)!Fabricante & ""
    Parametro(8) = rstTemp(0)!FoneFabricante & ""
    PercGarcom = rstTemp(0)!PercGarcom
    PercCover = rstTemp(0)!PercCover
  End If
  If Parametro(0) = "" Then
    Parametro(0) = "BARRACA`S SOFT"
  End If
  'Inicializa a Tabela T_Seguranca
  NrUsuarios = 0
  IdUsuario = 11
  SQL(0) = "SELECT * FROM T_Seguranca ORDER BY IdUsuario;"
  Set rstTemp(0) = dbs.OpenRecordset(SQL(0), dbOpenDynaset)
  If rstTemp(0).RecordCount = 0 Then
    For i = 0 To 10
      If i = 0 Then
        XX = "111111111111111"
      Else
        XX = "000000000000000"
      End If
      With rstTemp(0)
        .AddNew
        .Fields("IdUsuario").Value = Format(i, "0#")
        .Fields("Autorizacao").Value = XX
        .Update
      End With
    Next i
  Else
    SQL(0) = "SELECT * FROM T_Seguranca ORDER BY IdUsuario;"
    Set rstTemp(0) = dbs.OpenRecordset(SQL(0), dbOpenDynaset)
    rstTemp(0).MoveFirst
    i = 0
    While rstTemp(0).EOF <> True
      Usuarios(i, 0) = rstTemp(0)!Usuario & ""
      Usuarios(i, 1) = rstTemp(0)!Senha & ""
      Usuarios(i, 2) = rstTemp(0)!Autorizacao & ""
      If Usuarios(i, 1) <> "" Then
        NrUsuarios = NrUsuarios + 1
      End If
      i = i + 1
      rstTemp(0).MoveNext
    Wend
  End If
  rstTemp(0).Close
  If MesasDemo = 201 Then
    On Error GoTo ErroLeArquivo
    Open "C:\Windows\System\Winbs32.dll" For Input As #1
      Input #1, Proprietario
    Close #1
  Else
    Proprietario = "Verso Demo"
  End If
  If NrUsuarios = 0 Then
    Load frmSplash
  Else
    Load frmLogin
  End If
Exit Sub
ErroAbrirBanco:
  Z = 0
  Restaurar
  Resume Next
Exit Sub
ErroLeArquivo:
  Close #1
  Load frmRegistro
End Sub

Private Sub Restaurar()
  MsgBox ("O Banco de Dados no foi encontrado." & Chr(13) & "Coloque o disquete com a cpia, clique OK e tente novamente."), vbInformation + vbOKOnly, _
  "Impossvel Abrir Banco de Dados"
  XX = App.Path
  If Len(XX) > 11 Then XX = Mid(XX, 1, 9) & "~1"
  X = Shell("ARJ e A:\Dados.arj -va " & XX, 0)
  End
End Sub

Sub UpperCase(KeyAscii As Integer)
  'digitao em maisculas
  If Chr(KeyAscii) = "'" Then KeyAscii = 0
  Dim Char As String
  Char = Chr(KeyAscii)
  KeyAscii = Asc(UCase(Char))
End Sub

Sub OnlyNumbers(KeyAscii As Integer)
  'digitao s aceita nmeros
  Dim Char As String
  Char = Chr(KeyAscii)
  KeyAscii = Asc(UCase(Char))
  If KeyAscii = 8 Then Exit Sub
  If KeyAscii < 48 Or KeyAscii > 57 Then KeyAscii = 0
End Sub

Sub SoNumVigPonto(KeyAscii As Integer)
  'digitao s aceita nmeros, vrgulas e pontos
  Dim Char As String
  Char = Chr(KeyAscii)
  KeyAscii = Asc(UCase(Char))
  If KeyAscii = 8 Or KeyAscii = 44 Or KeyAscii = 46 Then Exit Sub
  If KeyAscii < 48 Or KeyAscii > 57 Then KeyAscii = 0
End Sub

Sub NumbersMenos(KeyAscii As Integer)
  'digitao de nmeros e sinal de menos
  Select Case KeyAscii
  Case 8, 13, 45, 48 To 57
    Case Else: KeyAscii = 0
  End Select
End Sub

Sub NumbersAndSigns(KeyAscii As Integer)
  'digitao de Backspace, Enter,Parnteses, _
  Menos,Ponto e Nmeros
  Select Case KeyAscii
  Case 8, 13, 32, 37, 40, 41, 45, 46, 47, 48 To 57
    Case Else: KeyAscii = 0
  End Select
End Sub

Sub NumbersAndVirgula(KeyAscii As Integer)
  'digitao de Backspace, Enter, Ponto e Nmeros
  Select Case KeyAscii
  Case 8, 13, 44, 48 To 57
    Case Else: KeyAscii = 0
  End Select
End Sub

Sub ValidaCPF()
  'Valida CPF
  Dim VerificaCPF As String
  Dim soma As Integer
  Dim Resto As Integer
  VerificaCPF = ""
  For n = 1 To Len(CPF)
    If Mid(CPF, n, 1) <> "." And _
      Mid(CPF, n, 1) <> "-" Then
      VerificaCPF = VerificaCPF + Mid(CPF, n, 1)
    End If
  Next n
  If Len(VerificaCPF) <> 11 Then
    Valido = False
    Exit Sub
  End If
  soma = 0
  For n = 1 To 9
    soma = soma + Val(Mid(VerificaCPF, n, 1)) * (11 - n)
  Next n
  Resto = 11 - (soma - (Int(soma / 11) * 11))
  If Resto = 10 Or Resto = 11 Then Resto = 0
  If Resto <> Val(Mid(VerificaCPF, 10, 1)) Then
    Valido = False
    Exit Sub
  End If
  soma = 0
  For n = 1 To 10
    soma = soma + Val(Mid(VerificaCPF, n, 1)) * (12 - n)
  Next n
  Resto = 11 - (soma - (Int(soma / 11) * 11))
  If Resto = 10 Or Resto = 11 Then Resto = 0
  If Resto <> Val(Mid(VerificaCPF, 11, 1)) Then
    Valido = False
    Exit Sub
  End If
  Valido = True
End Sub

Sub AlteraCaracteres()
  'Altera Caracteres especiais p/impresso modo DOS
  For ii = 1 To Len(XX)
    If Mid(XX, ii, 1) = "" Or Mid(XX, ii, 1) = "" Or Mid(XX, ii, 1) = "" Or Mid(XX, ii, 1) = "" Then Mid(XX, ii, 1) = "A"
    If Mid(XX, ii, 1) = "" Or Mid(XX, ii, 1) = "" Or Mid(XX, ii, 1) = "" Or Mid(XX, ii, 1) = "" Then Mid(XX, ii, 1) = "a"
    If Mid(XX, ii, 1) = "" Or Mid(XX, ii, 1) = "" Or Mid(XX, ii, 1) = "" Then Mid(XX, ii, 1) = "E"
    If Mid(XX, ii, 1) = "" Or Mid(XX, ii, 1) = "" Or Mid(XX, ii, 1) = "" Then Mid(XX, ii, 1) = "e"
    If Mid(XX, ii, 1) = "" Then Mid(XX, ii, 1) = "I"
    If Mid(XX, ii, 1) = "" Then Mid(XX, ii, 1) = "i"
    If Mid(XX, ii, 1) = "" Or Mid(XX, ii, 1) = "" Or Mid(XX, ii, 1) = "" Or Mid(XX, ii, 1) = "" Then Mid(XX, ii, 1) = "O"
    If Mid(XX, ii, 1) = "" Or Mid(XX, ii, 1) = "" Or Mid(XX, ii, 1) = "" Or Mid(XX, ii, 1) = "" Then Mid(XX, ii, 1) = "o"
    If Mid(XX, ii, 1) = "" Or Mid(XX, ii, 1) = "" Or Mid(XX, ii, 1) = "" Then Mid(XX, ii, 1) = "U"
    If Mid(XX, ii, 1) = "" Or Mid(XX, ii, 1) = "" Or Mid(XX, ii, 1) = "" Then Mid(XX, ii, 1) = "u"
    If Mid(XX, ii, 1) = "" Then Mid(XX, ii, 1) = "C"
    If Mid(XX, ii, 1) = "" Then Mid(XX, ii, 1) = "c"
    If Mid(XX, ii, 1) = "," Then Mid(XX, ii, 1) = "@"
    If Mid(XX, ii, 1) = "" Then Mid(XX, ii, 1) = "o"
    If Mid(XX, ii, 1) = "" Then Mid(XX, ii, 1) = "a"
  Next ii
End Sub
